#include <sourcemod>
#include <sdktools>

#define COLOR_DEFAULT 0x01
#define COLOR_GREEN 0x04

#define PLUGIN_VERSION "1.0"

new Handle:g_PEnabled = INVALID_HANDLE;

new bool:g_bPiss[MAXPLAYERS + 1] =  { false, ... }
new bool:g_bCanPiss[MAXPLAYERS + 1] =  { true, ... }

new BeamSprite;
new HaloSprite;

static const String:Weapons[][] =  { "spade", "amerknife" };

public Plugin:myinfo = 
{
	name = "PissMod", 
	author = "Andi67", 
	description = "Enables pissing in DODS", 
	version = PLUGIN_VERSION, 
	url = "www.andi67-blog.de.vu"
}

public OnPluginStart()
{
	g_PEnabled = CreateConVar("dod_piss_enabled", "1");
	
	HookEvent("player_hurt", EventPlayerHurt);
}

public OnMapStart()
{
	BeamSprite = PrecacheModel("materials/sprites/xbeam22.vmt");
	HaloSprite = PrecacheModel("materials/sprites/halo012.vmt");
	
	AddFileToDownloadsTable("materials/sprites/xbeam22.vmt");
	AddFileToDownloadsTable("materials/sprites/halo012.vmt");
	
	AddFileToDownloadsTable("sound/poop/pee.wav");
	PrecacheSound("poop/pee.wav", true);
	
	AddFileToDownloadsTable("sound/poop/laugh.mp3");
	PrecacheSound("poop/laugh.mp3", true);
}

//////////////////////////
//		  EVENTS	    //
//////////////////////////

public OnGameFrame()
{
	new Float:pos[3];
	new Float:end[3];
	new Float:ang[3];
	for (new i = 1; i <= MaxClients; ++i)
	{
		if (IsClientConnected(i))
		{
			if (g_bPiss[i])
			{
				GetClientEyePosition(i, pos);
				GetClientEyeAngles(i, ang);
				pos[2] -= 23.0;
				ang[0] = 50.0;
				
				TR_TraceRayFilter(pos, ang, MASK_PLAYERSOLID, RayType_Infinite, DontHitSelf, i);
				
				TR_GetEndPosition(end);
				
				TE_SetupBeamRingPoint(end, 5.0, 10.0, BeamSprite, HaloSprite, 0, 15, 0.5, 5.0, 1.0, { 255, 255, 0, 255 }, 10, 0);
				TE_SendToAll();
				
				new Float:ppos[3];
				
				GetClientEyePosition(i, ppos);
				
				ppos[2] -= 30.0;
				
				new Float:aang[3];
				
				GetClientEyeAngles(i, aang);
				
				if (aang[1] > 0)
				{
					ppos[0] += FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), aang[1]));
					ppos[1] += FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(aang[1], 90.0))));
				}
				else
				{
					ppos[0] += FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(aang[1])));
					ppos[1] -= FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(FloatAbs(aang[1]), 90.0))));
				}
				
				
				aang[0] = 0.0;
				aang[1] += 180.0;
				aang[2] = 0.0;
				
				TE_SetupBeamPoints(end, ppos, BeamSprite, HaloSprite, 1, 30, 0.1, 1.0, 1.0, 0, 10.0, { 255, 255, 0, 255 }, 10);
				TE_SendToAll();
			}
		}
	}
}

public EventPlayerHurt(Handle:event, const String:name[], bool:dontBroadcast)
{
	if (GetConVarInt(g_PEnabled) == 1)
	{
		new victim = GetClientOfUserId(GetEventInt(event, "userid"));
		new attacker = GetClientOfUserId(GetEventInt(event, "attacker"));
		
		if (g_bCanPiss[attacker])
		{
			decl String:weapon[512];
			GetEventString(event, "weapon", weapon, sizeof(weapon));
			
			for (new i = 0; i < sizeof(Weapons); i++)
			{
				if (StrEqual(weapon, Weapons[i], false))
				{
					if (GetClientHealth(victim) < 1)
					{
						new Float:rposition[3];
						new Float:cposition[3];
						//						GetEntDataVector(victim, Prop_Send, "m_vecOrigin", rposition);
						GetClientAbsOrigin(victim, rposition);
						GetClientAbsOrigin(attacker, cposition);
						if (rposition[0] > cposition[0] - 50 && rposition[0] < cposition[0] + 50)
						{
							if (rposition[1] > cposition[1] - 50 && rposition[1] < cposition[1] + 50)
							{
								if (rposition[2] > cposition[2] - 5 && rposition[2] < cposition[2] + 5)
								{
									new String:attackername[32];
									new String:victimname[32];
									GetClientName(attacker, attackername, sizeof(attackername));
									GetClientName(victim, victimname, sizeof(victimname));
									
									new Float:pos[3];
									new Float:end[3];
									new Float:ang[3];
									GetClientEyePosition(attacker, pos);
									GetClientEyeAngles(attacker, ang);
									pos[2] -= 5.0;
									ang[0] = 50.0;
									TR_TraceRayFilter(pos, ang, MASK_PLAYERSOLID, RayType_Infinite, DontHitSelf, attacker);
									TR_GetEndPosition(end);
									
									TE_SetupBeamRingPoint(end, 5.0, 10.0, BeamSprite, HaloSprite, 0, 15, 0.5, 5.0, 1.0, { 255, 255, 0, 255 }, 10, 0);
									TE_SendToAll();
									
									g_bPiss[attacker] = true;
									SetEntityMoveType(attacker, MOVETYPE_NONE);
									
									EmitAmbientSound("poop/pee.wav", pos);
									CreateTimer(0.8, EmitPissSound, attacker, TIMER_REPEAT);
									
									
									new Float:ppos[3];
									
									GetClientEyePosition(attacker, ppos);
									
									ppos[0] += 10.0;
									ppos[2] -= 30.0;
									
									new Float:aang[3];
									
									GetClientAbsAngles(attacker, aang);
									
									if (aang[1] > 0)
									{
										ppos[0] += FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), aang[1]));
										ppos[1] += FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(aang[1], 90.0))));
									}
									else
									{
										ppos[0] += FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(aang[1])));
										ppos[1] -= FloatSub(10.0, FloatMul(FloatDiv(10.0, 90.0), FloatAbs(FloatSub(FloatAbs(aang[1]), 90.0))));
									}
									
									aang[0] = 0.0;
									aang[1] += 180.0;
									aang[2] = 0.0;
									
									TE_SetupBeamPoints(end, ppos, BeamSprite, HaloSprite, 0, 30, 0.1, 1.0, 1.0, 0, 10.0, { 255, 255, 0, 255 }, 10);
									TE_SendToAll();
									
									PrintToChatAll("%c [Piss-Mod] %c %s is pissing on %s's dead body.", COLOR_GREEN, COLOR_DEFAULT, attackername, victimname);
									PrintCenterTextAll("[Piss-Mod] %s is pissing on %s's dead body.", attackername, victimname);
									EmitAmbientSound("poop/laugh.mp3", ppos);
									CreateTimer(5.0, Piss_Out, attacker);
									if (GetClientHealth(attacker) < 1)
									{
										CreateTimer(0.1, Piss_Out, attacker);
									}
								}
							}
						}
					}
				}
			}
		}
	}
}

public Action:Piss_Out(Handle:timer, any:client)
{
	g_bPiss[client] = false;
	g_bCanPiss[client] = false;
	
	if (IsValidClient(client))
	{
		CreateTimer(0.1, CanPiss, client);
		
		SetEntityMoveType(client, MOVETYPE_WALK);
	}
	return Plugin_Handled;
}

public bool:DontHitSelf(entity, mask, any:data)
{
	if (entity == data)
		return false;
	return true;
}

public Action:EmitPissSound(Handle:timer, any:client)
{
	if (!g_bPiss[client])
		return Plugin_Stop;
	
	if (IsValidClient(client))
	{
		new Float:pos[3];
		GetClientAbsOrigin(client, pos);
		
		EmitAmbientSound("poop/pee.wav", pos);
	}
	
	return Plugin_Continue;
}

public Action:CanPiss(Handle:timer, any:client)
{
	g_bCanPiss[client] = true;
	
	return Plugin_Continue;
}

public IsValidClient(client)
{
	if (!(1 <= client <= MaxClients) || !IsClientInGame(client))
		return false;
	
	return true;
} 